/* PRTDEMO.C Get setup from PRINTER.BIN and display strings  MDK 11.3.91 */
/*                    																	 */
#include <dos.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys\types.h>
#include <sys\stat.h>

unsigned char ShowCodes( void);
unsigned int  Setrowline( unsigned char row, unsigned char line);

struct PRT
	{
	char pins;               			/* Number of pins for graphics */
	char code;               			/* Printer control code set  */
	char ncode;              			/* Number of Control codes   */
	char dir;                        /* Direction 0 to 3 */
	int  flag;                       /* Flags from PRTMODEL.ASC */
	int  width;              			/* Printer width = 100 * inches */
	char mfg[20];                    /* Manufacturer string */
	char type;                       /* DM, LS, or IJ */
	char color;              			/* Printer number of colors  */
	char ctype;                      /* Color type B&W/W&B/CMY/RGB */
	char resv;               			/* reserved */
	int  head;               			/* Pin spacing in head */
	int  length;             			/* Printer length = 100 * inches */
	char model[20];            			/* Manufacturer and Model */
	} Prt;                   			/* length = 56 bytes */

struct PCODE
	{
	char type[6];            /* Type of control code */
	int  size;               /* numeric value (dpi or # colors) */
	char code1[18];          /* Control code (binary) */
	char code2[2];
	} Pcode[20];             /* length = 28 * 20 = 560 */

main()
	{
	FILE *ifile;
	unsigned char prtcodes, prtmodel, b[8];
	unsigned int i, j;

	clrscr();

	Prt.pins = 0;                                 /* Clear structures */
	for( i=0; i<20; i++)
		{
		for( j=0; j<30; j++) Pcode[i].type[j] = 0;
		}

	if((ifile = fopen("PRINTER.BIN", "rb")) == NULL)
		{
		printf("\n***ERROR*** Can not open PRINTER.BIN !!!");
		exit(0);
		}
	fread(&Prt.pins, 1, 56, ifile);             		/* Re-read Structures */
	fread(&Pcode[0].type[0], 1, (28*Prt.ncode), ifile);
	fclose(ifile);

	clrscr();
	printf("PRTREAD: Program to read PRINTER.BIN file and display data.\n");
	printf("======== ------- -- ---- ----------- ---- --- ------- -----\n");
	ShowCodes();
	gets(b);

	exit(0);
	} /********************** END OF MAIN ********************************/

unsigned char ShowCodes( void)
	{
	int i, j;
	char *typ[] = {"Dot-matrix", "Laser", "Ink-jet"};
	char *dir[] = {"Up", "Down", "Right", "Left"};
	char *rib[] = {"B&W", "W&B", "CMY", "RGB", "ALL"};

	printf("\n  Printer: %s %s    Code Set: %d", Prt.mfg, Prt.model, Prt.code);
	printf("    Type: %s", typ[Prt.type]);
	printf("\n  Graphics direction is %s", dir[Prt.dir]);
	if( Prt.color < 5) printf(" with %s ribbon.", rib[Prt.ctype]);
	else                printf(" with %d pens.", Prt.color);
	printf("\n  Pins:%3d      Head:%4d      Wide:%5d",
			 Prt.pins, Prt.head, Prt.width);
	printf("\n  Color:%2d      Flag:%4d      Long:%5d\n",
			 Prt.color, Prt.flag, Prt.length);
	i = 0;
	while( Pcode[i].type[0] > 0)
		{
		printf("\n%6s   %4d   ", Pcode[i].type, Pcode[i].size);
		j = 0;
		while( Pcode[i].code1[j] != 0)
			{
			printf(" %u", Pcode[i].code1[j]);
			j++;
			}
		printf(" %c", Pcode[i].type[5]);
		j = 0;
		while( Pcode[i].code2[j] != 0)
			{
			printf(" %u", Pcode[i].code2[j]);
			j++;
			}
		i++;
		}
	return(0);
	}

unsigned int Setrowline(rw, l)
unsigned char rw, l;
{
     union REGS reg;

     reg.h.ah = 0x02;
     reg.h.bh = 0x00;
     reg.h.dh = rw;
     reg.h.dl = l;
     int86(0x10, &reg, &reg);
}

